
_LCD_init:

;LCDv1.c,12 :: 		void LCD_init(void)
;LCDv1.c,14 :: 		Delay_ms(17);
	MOVLW      45
	MOVWF      R12+0
	MOVLW      38
	MOVWF      R13+0
L_LCD_init0:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_init0
	DECFSZ     R12+0, 1
	GOTO       L_LCD_init0
	NOP
;LCDv1.c,15 :: 		LCD_Write(0x30);
	MOVLW      48
	MOVWF      FARG_LCD_Write_Dat+0
	CALL       _LCD_Write+0
;LCDv1.c,16 :: 		Delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_LCD_init1:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_init1
	DECFSZ     R12+0, 1
	GOTO       L_LCD_init1
	NOP
	NOP
;LCDv1.c,17 :: 		LCD_Write(0x30);
	MOVLW      48
	MOVWF      FARG_LCD_Write_Dat+0
	CALL       _LCD_Write+0
;LCDv1.c,18 :: 		Delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_LCD_init2:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_init2
	DECFSZ     R12+0, 1
	GOTO       L_LCD_init2
	NOP
	NOP
;LCDv1.c,19 :: 		LCD_Write(0x30);
	MOVLW      48
	MOVWF      FARG_LCD_Write_Dat+0
	CALL       _LCD_Write+0
;LCDv1.c,20 :: 		Delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_LCD_init3:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_init3
	DECFSZ     R12+0, 1
	GOTO       L_LCD_init3
	NOP
	NOP
;LCDv1.c,21 :: 		LCD_Write(0x20);  //4 bit wide bus
	MOVLW      32
	MOVWF      FARG_LCD_Write_Dat+0
	CALL       _LCD_Write+0
;LCDv1.c,23 :: 		LCD_Send_Cmd(0x28);           //4bit wide bus 2 rows
	MOVLW      40
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
;LCDv1.c,24 :: 		LCD_Send_Cmd(0x10);
	MOVLW      16
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
;LCDv1.c,25 :: 		LCD_Send_Cmd(0x01);
	MOVLW      1
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
;LCDv1.c,26 :: 		LCD_Send_Cmd(0x0F);
	MOVLW      15
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
;LCDv1.c,28 :: 		LCD_Send_Cmd(LCD_CMD_Cursor_Off);
	MOVLW      12
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
;LCDv1.c,29 :: 		LCD_Send_Cmd(LCD_CMD_Clear);
	MOVLW      1
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
;LCDv1.c,30 :: 		Delay_ms(10);
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_LCD_init4:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_init4
	DECFSZ     R12+0, 1
	GOTO       L_LCD_init4
	NOP
;LCDv1.c,31 :: 		}
L_end_LCD_init:
	RETURN
; end of _LCD_init

_LCD_Write:

;LCDv1.c,33 :: 		void LCD_Write(u8 Dat)
;LCDv1.c,35 :: 		SPI_DAT&=(LCD_RS_BIT|LCD_BackLight_BIT);
	MOVLW      6
	ANDWF      _SPI_DAT+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _SPI_DAT+0
;LCDv1.c,36 :: 		SPI_DAT|=(Dat&LCD_Data_Mask)|LCD_E_BIT;
	MOVLW      240
	ANDWF      FARG_LCD_Write_Dat+0, 0
	MOVWF      R0+0
	BSF        R0+0, 3
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _SPI_DAT+0
;LCDv1.c,37 :: 		MC74HC595_SendByte(SPI_DAT);
	MOVF       R0+0, 0
	MOVWF      FARG_MC74HC595_SendByte_Byte+0
	CALL       _MC74HC595_SendByte+0
;LCDv1.c,38 :: 		Delay_us(5);
	MOVLW      3
	MOVWF      R13+0
L_LCD_Write5:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Write5
;LCDv1.c,39 :: 		SPI_DAT&=~LCD_E_BIT;
	MOVLW      247
	ANDWF      _SPI_DAT+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _SPI_DAT+0
;LCDv1.c,40 :: 		MC74HC595_SendByte(SPI_DAT);
	MOVF       R0+0, 0
	MOVWF      FARG_MC74HC595_SendByte_Byte+0
	CALL       _MC74HC595_SendByte+0
;LCDv1.c,41 :: 		Delay_us(5);
	MOVLW      3
	MOVWF      R13+0
L_LCD_Write6:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Write6
;LCDv1.c,42 :: 		}
L_end_LCD_Write:
	RETURN
; end of _LCD_Write

_LCD_Send_Cmd:

;LCDv1.c,43 :: 		void LCD_Send_Cmd(u8 CMD)
;LCDv1.c,45 :: 		Delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_LCD_Send_Cmd7:
	DECFSZ     R13+0, 1
	GOTO       L_LCD_Send_Cmd7
	DECFSZ     R12+0, 1
	GOTO       L_LCD_Send_Cmd7
	NOP
	NOP
;LCDv1.c,46 :: 		SPI_DAT&=~LCD_RS_BIT;
	BCF        _SPI_DAT+0, 2
;LCDv1.c,47 :: 		LCD_Write((CMD&0xF0));
	MOVLW      240
	ANDWF      FARG_LCD_Send_Cmd_CMD+0, 0
	MOVWF      FARG_LCD_Write_Dat+0
	CALL       _LCD_Write+0
;LCDv1.c,48 :: 		LCD_Write(((CMD&0x0F)<<4));
	MOVLW      15
	ANDWF      FARG_LCD_Send_Cmd_CMD+0, 0
	MOVWF      FARG_LCD_Write_Dat+0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	CALL       _LCD_Write+0
;LCDv1.c,49 :: 		}
L_end_LCD_Send_Cmd:
	RETURN
; end of _LCD_Send_Cmd

_lcd_set_position:

;LCDv1.c,51 :: 		void lcd_set_position(u8 row, u8 colum)
;LCDv1.c,53 :: 		u8 position = 0x80;
	MOVLW      128
	MOVWF      lcd_set_position_position_L0+0
;LCDv1.c,54 :: 		if (row > 0) { position |= 0x40;}
	MOVF       FARG_lcd_set_position_row+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L_lcd_set_position8
	BSF        lcd_set_position_position_L0+0, 6
L_lcd_set_position8:
;LCDv1.c,55 :: 		LCD_Send_Cmd(position | colum);
	MOVF       FARG_lcd_set_position_colum+0, 0
	IORWF      lcd_set_position_position_L0+0, 0
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
;LCDv1.c,56 :: 		}
L_end_lcd_set_position:
	RETURN
; end of _lcd_set_position

_lcd_write_data:

;LCDv1.c,58 :: 		void lcd_write_data(u8 dat)
;LCDv1.c,60 :: 		Delay_us(50);
	MOVLW      33
	MOVWF      R13+0
L_lcd_write_data9:
	DECFSZ     R13+0, 1
	GOTO       L_lcd_write_data9
;LCDv1.c,61 :: 		SPI_DAT|=LCD_RS_BIT;
	BSF        _SPI_DAT+0, 2
;LCDv1.c,62 :: 		LCD_Write((dat&0xF0));
	MOVLW      240
	ANDWF      FARG_lcd_write_data_dat+0, 0
	MOVWF      FARG_LCD_Write_Dat+0
	CALL       _LCD_Write+0
;LCDv1.c,63 :: 		LCD_Write(((dat&0x0F)<<4));
	MOVLW      15
	ANDWF      FARG_lcd_write_data_dat+0, 0
	MOVWF      FARG_LCD_Write_Dat+0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	RLF        FARG_LCD_Write_Dat+0, 1
	BCF        FARG_LCD_Write_Dat+0, 0
	CALL       _LCD_Write+0
;LCDv1.c,64 :: 		}
L_end_lcd_write_data:
	RETURN
; end of _lcd_write_data

_lcd_print_char:

;LCDv1.c,66 :: 		void lcd_print_char(u8 dat)
;LCDv1.c,68 :: 		if (dat == '\n')
	MOVF       FARG_lcd_print_char_dat+0, 0
	XORLW      10
	BTFSS      STATUS+0, 2
	GOTO       L_lcd_print_char10
;LCDv1.c,69 :: 		{LCD_Send_Cmd(0x80 | 0x40);} else {lcd_write_data(dat);}
	MOVLW      192
	MOVWF      FARG_LCD_Send_Cmd_CMD+0
	CALL       _LCD_Send_Cmd+0
	GOTO       L_lcd_print_char11
L_lcd_print_char10:
	MOVF       FARG_lcd_print_char_dat+0, 0
	MOVWF      FARG_lcd_write_data_dat+0
	CALL       _lcd_write_data+0
L_lcd_print_char11:
;LCDv1.c,70 :: 		}
L_end_lcd_print_char:
	RETURN
; end of _lcd_print_char

_lcd_print_string:

;LCDv1.c,72 :: 		void lcd_print_string(u8 * string)
;LCDv1.c,74 :: 		while (*string != 0x00){ lcd_print_char(*string++);}
L_lcd_print_string12:
	MOVF       FARG_lcd_print_string_string+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_print_string13
	MOVF       FARG_lcd_print_string_string+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
	INCF       FARG_lcd_print_string_string+0, 1
	GOTO       L_lcd_print_string12
L_lcd_print_string13:
;LCDv1.c,75 :: 		}
L_end_lcd_print_string:
	RETURN
; end of _lcd_print_string

_lcd_print_value:

;LCDv1.c,77 :: 		void lcd_print_value(unsigned long val)
;LCDv1.c,79 :: 		u8 buffer[10] = {0};
	CLRF       lcd_print_value_buffer_L0+0
	CLRF       lcd_print_value_buffer_L0+1
	CLRF       lcd_print_value_buffer_L0+2
	CLRF       lcd_print_value_buffer_L0+3
	CLRF       lcd_print_value_buffer_L0+4
	CLRF       lcd_print_value_buffer_L0+5
	CLRF       lcd_print_value_buffer_L0+6
	CLRF       lcd_print_value_buffer_L0+7
	CLRF       lcd_print_value_buffer_L0+8
	CLRF       lcd_print_value_buffer_L0+9
	CLRF       lcd_print_value_cnt_L0+0
;LCDv1.c,82 :: 		if (val!=0)
	MOVLW      0
	MOVWF      R0+0
	XORWF      FARG_lcd_print_value_val+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_value37
	MOVF       R0+0, 0
	XORWF      FARG_lcd_print_value_val+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_value37
	MOVF       R0+0, 0
	XORWF      FARG_lcd_print_value_val+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_value37
	MOVF       FARG_lcd_print_value_val+0, 0
	XORLW      0
L__lcd_print_value37:
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_print_value14
;LCDv1.c,84 :: 		while( val )
L_lcd_print_value15:
	MOVF       FARG_lcd_print_value_val+0, 0
	IORWF      FARG_lcd_print_value_val+1, 0
	IORWF      FARG_lcd_print_value_val+2, 0
	IORWF      FARG_lcd_print_value_val+3, 0
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_print_value16
;LCDv1.c,87 :: 		val /= 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       FARG_lcd_print_value_val+0, 0
	MOVWF      R0+0
	MOVF       FARG_lcd_print_value_val+1, 0
	MOVWF      R0+1
	MOVF       FARG_lcd_print_value_val+2, 0
	MOVWF      R0+2
	MOVF       FARG_lcd_print_value_val+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_U+0
	MOVF       R0+0, 0
	MOVWF      FARG_lcd_print_value_val+0
	MOVF       R0+1, 0
	MOVWF      FARG_lcd_print_value_val+1
	MOVF       R0+2, 0
	MOVWF      FARG_lcd_print_value_val+2
	MOVF       R0+3, 0
	MOVWF      FARG_lcd_print_value_val+3
;LCDv1.c,88 :: 		cnt++;
	INCF       lcd_print_value_cnt_L0+0, 1
;LCDv1.c,89 :: 		}
	GOTO       L_lcd_print_value15
L_lcd_print_value16:
;LCDv1.c,90 :: 		while (cnt!=0){ cnt--; lcd_print_char(buffer[cnt]); }
L_lcd_print_value17:
	MOVF       lcd_print_value_cnt_L0+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_print_value18
	DECF       lcd_print_value_cnt_L0+0, 1
	MOVF       lcd_print_value_cnt_L0+0, 0
	ADDLW      lcd_print_value_buffer_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
	GOTO       L_lcd_print_value17
L_lcd_print_value18:
;LCDv1.c,91 :: 		}
	GOTO       L_lcd_print_value19
L_lcd_print_value14:
;LCDv1.c,94 :: 		lcd_print_char('0');
	MOVLW      48
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
;LCDv1.c,95 :: 		}
L_lcd_print_value19:
;LCDv1.c,96 :: 		}
L_end_lcd_print_value:
	RETURN
; end of _lcd_print_value

_lcd_print_hex_value:

;LCDv1.c,98 :: 		void lcd_print_hex_value(long val)
;LCDv1.c,100 :: 		char buffer[10] = {0};
	CLRF       lcd_print_hex_value_buffer_L0+0
	CLRF       lcd_print_hex_value_buffer_L0+1
	CLRF       lcd_print_hex_value_buffer_L0+2
	CLRF       lcd_print_hex_value_buffer_L0+3
	CLRF       lcd_print_hex_value_buffer_L0+4
	CLRF       lcd_print_hex_value_buffer_L0+5
	CLRF       lcd_print_hex_value_buffer_L0+6
	CLRF       lcd_print_hex_value_buffer_L0+7
	CLRF       lcd_print_hex_value_buffer_L0+8
	CLRF       lcd_print_hex_value_buffer_L0+9
	CLRF       lcd_print_hex_value_cnt_L0+0
;LCDv1.c,103 :: 		lcd_print_char('0');
	MOVLW      48
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
;LCDv1.c,104 :: 		lcd_print_char('x');
	MOVLW      120
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
;LCDv1.c,105 :: 		if (val<=9)        lcd_print_char('0');
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      FARG_lcd_print_hex_value_val+3, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_hex_value39
	MOVF       FARG_lcd_print_hex_value_val+2, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_hex_value39
	MOVF       FARG_lcd_print_hex_value_val+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_hex_value39
	MOVF       FARG_lcd_print_hex_value_val+0, 0
	SUBLW      9
L__lcd_print_hex_value39:
	BTFSS      STATUS+0, 0
	GOTO       L_lcd_print_hex_value20
	MOVLW      48
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
L_lcd_print_hex_value20:
;LCDv1.c,106 :: 		if (val!=0)
	MOVLW      0
	MOVWF      R0+0
	XORWF      FARG_lcd_print_hex_value_val+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_hex_value40
	MOVF       R0+0, 0
	XORWF      FARG_lcd_print_hex_value_val+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_hex_value40
	MOVF       R0+0, 0
	XORWF      FARG_lcd_print_hex_value_val+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__lcd_print_hex_value40
	MOVF       FARG_lcd_print_hex_value_val+0, 0
	XORLW      0
L__lcd_print_hex_value40:
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_print_hex_value21
;LCDv1.c,108 :: 		while( val )
L_lcd_print_hex_value22:
	MOVF       FARG_lcd_print_hex_value_val+0, 0
	IORWF      FARG_lcd_print_hex_value_val+1, 0
	IORWF      FARG_lcd_print_hex_value_val+2, 0
	IORWF      FARG_lcd_print_hex_value_val+3, 0
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_print_hex_value23
;LCDv1.c,111 :: 		val=val>>4;
	MOVLW      4
	MOVWF      R0+0
	MOVF       R0+0, 0
L__lcd_print_hex_value41:
	BTFSC      STATUS+0, 2
	GOTO       L__lcd_print_hex_value42
	RRF        FARG_lcd_print_hex_value_val+3, 1
	RRF        FARG_lcd_print_hex_value_val+2, 1
	RRF        FARG_lcd_print_hex_value_val+1, 1
	RRF        FARG_lcd_print_hex_value_val+0, 1
	BCF        FARG_lcd_print_hex_value_val+3, 7
	BTFSC      FARG_lcd_print_hex_value_val+3, 6
	BSF        FARG_lcd_print_hex_value_val+3, 7
	ADDLW      255
	GOTO       L__lcd_print_hex_value41
L__lcd_print_hex_value42:
;LCDv1.c,112 :: 		cnt++;
	INCF       lcd_print_hex_value_cnt_L0+0, 1
;LCDv1.c,113 :: 		}
	GOTO       L_lcd_print_hex_value22
L_lcd_print_hex_value23:
;LCDv1.c,114 :: 		while (cnt!=0){ cnt--; lcd_print_char(buffer[cnt]); }
L_lcd_print_hex_value24:
	MOVF       lcd_print_hex_value_cnt_L0+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_lcd_print_hex_value25
	DECF       lcd_print_hex_value_cnt_L0+0, 1
	MOVF       lcd_print_hex_value_cnt_L0+0, 0
	ADDLW      lcd_print_hex_value_buffer_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
	GOTO       L_lcd_print_hex_value24
L_lcd_print_hex_value25:
;LCDv1.c,115 :: 		}
	GOTO       L_lcd_print_hex_value26
L_lcd_print_hex_value21:
;LCDv1.c,118 :: 		lcd_print_char('0');
	MOVLW      48
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
;LCDv1.c,119 :: 		}
L_lcd_print_hex_value26:
;LCDv1.c,120 :: 		lcd_print_char(' ');
	MOVLW      32
	MOVWF      FARG_lcd_print_char_dat+0
	CALL       _lcd_print_char+0
;LCDv1.c,121 :: 		}
L_end_lcd_print_hex_value:
	RETURN
; end of _lcd_print_hex_value

_LCD_BackLight:

;LCDv1.c,123 :: 		void LCD_BackLight (unsigned char State)
;LCDv1.c,125 :: 		if (State)  SPI_DAT|=LCD_BackLight_BIT;
	MOVF       FARG_LCD_BackLight_State+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_LCD_BackLight27
	BSF        _SPI_DAT+0, 1
	GOTO       L_LCD_BackLight28
L_LCD_BackLight27:
;LCDv1.c,126 :: 		else   SPI_DAT&=~LCD_BackLight_BIT;
	BCF        _SPI_DAT+0, 1
L_LCD_BackLight28:
;LCDv1.c,127 :: 		}
L_end_LCD_BackLight:
	RETURN
; end of _LCD_BackLight
