
_MC74HC595_SendByte:

;MC74HC595.c,5 :: 		void MC74HC595_SendByte (unsigned char Byte)
;MC74HC595.c,7 :: 		CS=0;
	BCF        PORTC+0, 6
;MC74HC595.c,8 :: 		SPI1_Write(Byte);
	MOVF       FARG_MC74HC595_SendByte_Byte+0, 0
	MOVWF      FARG_SPI1_Write_data_+0
	CALL       _SPI1_Write+0
;MC74HC595.c,9 :: 		CS=1;
	BSF        PORTC+0, 6
;MC74HC595.c,10 :: 		}
L_end_MC74HC595_SendByte:
	RETURN
; end of _MC74HC595_SendByte

_MC74HC595_SendData:

;MC74HC595.c,12 :: 		void MC74HC595_SendData (unsigned char * Data)
;MC74HC595.c,14 :: 		unsigned char rData=0;
	CLRF       MC74HC595_SendData_rData_L0+0
;MC74HC595.c,15 :: 		CS=0;
	BCF        PORTC+0, 6
;MC74HC595.c,16 :: 		while (rData!=Data[0]) rData=SPI1_Read(* Data++);
L_MC74HC595_SendData0:
	MOVF       FARG_MC74HC595_SendData_Data+0, 0
	MOVWF      FSR
	MOVF       MC74HC595_SendData_rData_L0+0, 0
	XORWF      INDF+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_MC74HC595_SendData1
	MOVF       FARG_MC74HC595_SendData_Data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_SPI1_Read_buffer+0
	CALL       _SPI1_Read+0
	MOVF       R0+0, 0
	MOVWF      MC74HC595_SendData_rData_L0+0
	INCF       FARG_MC74HC595_SendData_Data+0, 1
	GOTO       L_MC74HC595_SendData0
L_MC74HC595_SendData1:
;MC74HC595.c,17 :: 		CS=1;
	BSF        PORTC+0, 6
;MC74HC595.c,18 :: 		}
L_end_MC74HC595_SendData:
	RETURN
; end of _MC74HC595_SendData
